﻿package com{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Graphics;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	import flash.utils.getDefinitionByName;
	
	public class RotationLines extends MovieClip{
		private var xmlLoader:URLLoader;
		private var myURLRequest:URLRequest;
		private var dataXml:XML;
		private var rotateBtn;
		private var anticlockBtn;
		private var stopBtn;
		private var centerLine;
		private var initRotation:Number;
		private var redLineMc;
		private var blueLineMc;
		private var myAngle=0;
		private var curveMc:Shape=new Shape();
		private var rad:Number=0;
		private var PI=(Math.PI/180);
		private var clockWise:Boolean = true;
		private var segLineThick = 0;
		private var segLineColor = "";
		private var segFillColor = "";
		
		public function RotationLines(){
			xmlLoader = new URLLoader();
			myURLRequest = new URLRequest("xml/confiq.xml");
			xmlLoader.load(myURLRequest);
			xmlLoader.addEventListener(Event.COMPLETE, onXmlLoaded);
		}
		
		private function onXmlLoaded(evt:Event){
			dataXml = new XML(evt.target.data);
			var totButtons = dataXml.Buttons.button.length();
			for(var i=1; i<=totButtons; i++){
				var myClassName = dataXml.Buttons.button[i-1].@classNam;
				var myClass:Class = getDefinitionByName(myClassName) as Class;
				var myBtn = new myClass();
				myBtn.name = myClassName;
				myBtn.x = dataXml.Buttons.button[i-1].@xpos;
				myBtn.y = dataXml.Buttons.button[i-1].@ypos;
				addChild(myBtn);
			}
			myClassName = dataXml.centerLine.@classNam;
			myClass = getDefinitionByName(myClassName) as Class;
			myBtn = new myClass();
			myBtn.name = myClassName;
			myBtn.x = dataXml.centerLine.@xpos;
			myBtn.y = dataXml.centerLine.@ypos;
			addChild(myBtn);
			segLineThick = Number(dataXml.Segment.@lineThick);
			segLineColor = dataXml.Segment.@lineColor;
			segFillColor = dataXml.Segment.@fillColor;
			rad = Number(dataXml.Segment.@radius);
			addListeners();
		}
		
		private function addListeners(){
			rotateBtn = getChildByName("rotateBtn");
			anticlockBtn = getChildByName("anticlockBtn");
			stopBtn = getChildByName("stopBtn");
			centerLine = getChildByName("lineMc");
			redLineMc = centerLine.getChildByName("redLineMc");
			blueLineMc = centerLine.getChildByName("blueLineMc");
			curveMc.graphics.lineStyle(segLineThick,segLineColor,1);
			centerLine.addChild(curveMc);
			centerLine.setChildIndex(curveMc, 0);
			initRotation = blueLineMc.rotation;
			rotateBtn.buttonMode = true;
			rotateBtn.addEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
			rotateBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			rotateBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			rotateBtn.addEventListener(MouseEvent.CLICK, onRotateFunc);
			anticlockBtn.buttonMode = true;
			anticlockBtn.addEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
			anticlockBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			anticlockBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			anticlockBtn.addEventListener(MouseEvent.CLICK, onAntiClockFunc);
			stopBtn.buttonMode = true;
			stopBtn.addEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
			stopBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			stopBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			stopBtn.addEventListener(MouseEvent.CLICK, onStopFunc);
			redLineMc.buttonMode = true;
			redLineMc.addEventListener(MouseEvent.MOUSE_DOWN, onRedLineDown);
			redLineMc.addEventListener(MouseEvent.MOUSE_UP, onRedLineUp);
			reset_btn.buttonMode = true;
			reset_btn.addEventListener(MouseEvent.CLICK, onResetFunc);
		}
		
		private function onResetFunc(obj:MouseEvent){
			blueLineMc.removeEventListener(Event.ENTER_FRAME, rotateLine);
			blueLineMc.rotation = initRotation;
			curveMc.graphics.clear();
			centerLine.rotation = 0;
			
			rotateBtn.buttonMode = true;
			rotateBtn.addEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
			rotateBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			rotateBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			rotateBtn.addEventListener(MouseEvent.CLICK, onRotateFunc);
			rotateBtn.gotoAndStop(1);
			anticlockBtn.buttonMode = true;
			anticlockBtn.addEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
			anticlockBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			anticlockBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			anticlockBtn.addEventListener(MouseEvent.CLICK, onAntiClockFunc);
			anticlockBtn.gotoAndStop(1);
		}
		
		private function onBtnDown(obj:MouseEvent){
			obj.currentTarget.gotoAndStop(3);
		}
		
		private function onBtnOver(obj:MouseEvent){
			obj.currentTarget.gotoAndStop(2);
		}
		
		private function onBtnOut(obj:MouseEvent){
			obj.currentTarget.gotoAndStop(1);
		}
		
		private function onRedLineDown(obj:MouseEvent){
			blueLineMc.removeEventListener(Event.ENTER_FRAME, rotateLine);
			blueLineMc.rotation = initRotation;
			curveMc.graphics.clear();
			redLineMc.addEventListener(Event.ENTER_FRAME, onMoveLine);
			redLineMc.parent.stage.addEventListener(MouseEvent.MOUSE_UP, onRedLineUp);
		}
		
		private function onRedLineUp(obj:MouseEvent){
			redLineMc.removeEventListener(Event.ENTER_FRAME, onMoveLine);
			redLineMc.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, onRedLineUp);
		}
		
		private function onMoveLine(evt:Event){
			var distanceX : Number = (mouseX - (centerLine.x));
			var distanceY : Number = (mouseY - (centerLine.y));
			myAngle = Math.round(Math.atan2(distanceY, distanceX) * (180 / Math.PI));
			centerLine.rotation = myAngle+90;
			//trace("myAngleMov = "+myAngle);
			
		}
		
		private function onRotateFunc(obj:MouseEvent){
			clockWise = true;
			blueLineMc.addEventListener(Event.ENTER_FRAME, rotateLine);
			rotateBtn.buttonMode = false;
			rotateBtn.removeEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
			rotateBtn.removeEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			rotateBtn.removeEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			rotateBtn.removeEventListener(MouseEvent.CLICK, onRotateFunc);
			rotateBtn.gotoAndStop(3);
			anticlockBtn.buttonMode = true;
			anticlockBtn.addEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
			anticlockBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			anticlockBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			anticlockBtn.addEventListener(MouseEvent.CLICK, onAntiClockFunc);
			anticlockBtn.gotoAndStop(1);
		}
		
		private function rotateLine(evt:Event){
			if(clockWise == true){
				evt.currentTarget.rotation += .5;
			}else{
				evt.currentTarget.rotation -=.5;
			}
			//trace("  --  "+evt.currentTarget.rotation);
			myAngle = evt.currentTarget.rotation;
			if(myAngle<0){
				myAngle = 360+myAngle;
			}
			drawCurve();
		}
		
		private function drawCurve() {
			curveMc.graphics.clear();
			curveMc.graphics.lineStyle(segLineThick, segLineColor, 1);
			curveMc.graphics.beginFill(segFillColor, 1);
			curveMc.graphics.moveTo(redLineMc.x, redLineMc.y);
			for (var i=0; i<=myAngle; i++) {
				//var ang =  360-i;
				var ang =  i-90;
				var xMov = redLineMc.x+Math.cos(ang*PI)*rad;
				var yMov = redLineMc.y+Math.sin(ang*PI)*rad;
				curveMc.graphics.lineTo(xMov, yMov);
			}
			curveMc.graphics.endFill();
			
		}
		
		private function onAntiClockFunc(obj:MouseEvent){
			clockWise = false;
			blueLineMc.addEventListener(Event.ENTER_FRAME, rotateLine);
			anticlockBtn.buttonMode = false;
			anticlockBtn.removeEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
			anticlockBtn.removeEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			anticlockBtn.removeEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			anticlockBtn.removeEventListener(MouseEvent.CLICK, onAntiClockFunc);
			anticlockBtn.gotoAndStop(3);
			rotateBtn.buttonMode = true;
			rotateBtn.addEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
			rotateBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			rotateBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			rotateBtn.addEventListener(MouseEvent.CLICK, onRotateFunc);
			rotateBtn.gotoAndStop(1);
		}
		
		private function onStopFunc(obj:MouseEvent) {
			rotateBtn.buttonMode = true
			rotateBtn.gotoAndStop(1)
			rotateBtn.addEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
			rotateBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			rotateBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			rotateBtn.addEventListener(MouseEvent.CLICK, onRotateFunc);
			anticlockBtn.addEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
			anticlockBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			anticlockBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			anticlockBtn.addEventListener(MouseEvent.CLICK, onAntiClockFunc);
			anticlockBtn.buttonMode = true;
			anticlockBtn.gotoAndStop(1)
			blueLineMc.removeEventListener(Event.ENTER_FRAME, rotateLine);
		}
	}
}