﻿package com{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Graphics;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.utils.getDefinitionByName;
	import flash.geom.ColorTransform;
	
	public class Spinner extends MovieClip{
		private var circleMc:MovieClip;
		private var arrowMc;
		private var sectionMc:MovieClip;
		private var lineMc:MovieClip;
		private var rad:Number = 180;
		private var PI=(Math.PI/180);
		private var currSection:Number = 1;
		private var beginX = 380;
		private var beginY = 220;
		private var sectionArr = [2,3,4,6,8,12];
		private var sectionAngArr:Array;
		private var colorArr = ["0xED1B24", "0x40AF49", "0xFFDD00"];
		private var btnClickCnt = 0;
		private var rotateValue = 0;
		private var myAngle = 0;
		private var initRotation = 0;
		
		public function Spinner(){
			sectionMc = new MovieClip();
			addChild(sectionMc);
			lineMc = new MovieClip();
			addChild(lineMc);
			circleMc = new MovieClip();
			addChild(circleMc);
			addObjects();
			addArrow();
			addListeners();
		}
		
		private function addObjects(){
			buildSection();
			buildLine();
			buildCircle();
		}
		
		private function addArrow(){
			var myClass:Class = getDefinitionByName("arrow") as Class;
			arrowMc = new myClass;
			arrowMc.x = beginX;
			arrowMc.y = beginY;
			addChild(arrowMc);
			initRotation = arrowMc.rotation;
		}
		
		private function addListeners(){
			for(var i=1; i<=6; i++){
				var myBtn = this["btn_"+i];
				myBtn.Num = i;
				myBtn.buttonMode = true;
				myBtn.mouseChildren = false;
				myBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
				myBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
				myBtn.addEventListener(MouseEvent.CLICK, showSection);
			}
			myBtn = this["btn_"+1];
			myBtn.mouseEnabled = false;
			myBtn.gotoAndStop(3);
			spin.buttonMode =  true;
			spin.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			spin.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			spin.addEventListener(MouseEvent.CLICK, rotateCircle);
			reset_btn.addEventListener(MouseEvent.CLICK, onResetFunc);
		}
		
		private function onResetFunc(obj:MouseEvent){
			arrowMc.rotation = initRotation;
			var myBtn = this["btn_"+1];
			myBtn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
		}
		
		private function rotateCircle(e:Event){
			if(btnClickCnt == 0){
				myAngle=Math.floor(Math.random()*(1+359))+0;
			}
			btnClickCnt++;
			arrowMc.addEventListener(Event.ENTER_FRAME, rotate);
		}

		private function rotate(e:Event = null){
			if(rotateValue<myAngle && rotateValue+20<myAngle){		
				rotateValue=rotateValue+20;
				arrowMc.rotation=arrowMc.rotation+20;
		
			}else{	
				arrowMc.rotation=arrowMc.rotation+(myAngle-rotateValue);			
				rotateValue=myAngle-360;
		
				btnClickCnt--;
				if(btnClickCnt > 0){
					myAngle=Math.floor(Math.random()*(1+359))+0;
				}else{
					arrowMc.removeEventListener(Event.ENTER_FRAME, rotate);
				}
		
			}	
		}
		
		private function onBtnOver(obj:MouseEvent){
			obj.currentTarget.gotoAndStop(2);
		}
		
		private function onBtnOut(obj:MouseEvent){
			obj.currentTarget.gotoAndStop(1);
		}
		
		private function showSection(obj:MouseEvent){
			currSection = obj.currentTarget.Num;
			for(var i=1; i<=6; i++){
				var myBtn = this["btn_"+i];
				myBtn.mouseEnabled = true;
				myBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
				myBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
				myBtn.gotoAndStop(1);
			}
			myBtn = this["btn_"+obj.currentTarget.Num];
			myBtn.mouseEnabled = false;
			myBtn.removeEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			myBtn.removeEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			myBtn.gotoAndStop(3);
			addObjects();
		}
		
		private function buildSection(){
			if(sectionMc != null){
				while(sectionMc.numChildren){
					sectionMc.removeChildAt(0);
				}
			}
			sectionAngArr = new Array();
			var beginAng = 0;
			var endAng = 0;
			for(var i=1; i<=sectionArr[currSection-1]; i++){
				endAng = beginAng+(360/sectionArr[currSection-1]);
				sectionAngArr.push(beginAng+"_"+endAng);
				beginAng += (360/sectionArr[currSection-1]);
			}
			var colorNum = 1;
			for(i=1; i<=sectionArr[currSection-1]; i++){
				var mySection = new MovieClip();
				mySection.name = "mySection"+i;
				sectionMc.addChild(mySection);
				var myShape:Shape = new Shape();
				myShape.graphics.clear();
				myShape.graphics.lineStyle(2, 0x000000, 0);
				myShape.graphics.beginFill(colorArr[colorNum-1], 1);
				myShape.graphics.moveTo(beginX, beginY);
				beginAng = Number(sectionAngArr[i-1].split("_")[0]);
				endAng = Number(sectionAngArr[i-1].split("_")[1]);
				for (var j=beginAng; j<=endAng; j++) {
					var ang =  j-90;
					var xMov = beginX+Math.cos(ang*PI)*rad;
					var yMov = beginY+Math.sin(ang*PI)*rad;
					myShape.graphics.lineTo(xMov, yMov);
				}	
				myShape.graphics.endFill();
				mySection.addChild(myShape);
				mySection.colorNum = colorNum;
				mySection.buttonMode = true;
				mySection.addEventListener(MouseEvent.CLICK, changeColor);
				if(++colorNum>colorArr.length){
					colorNum=1;
				}
			}
		}
		
		private function changeColor(obj:MouseEvent){
			var myCurrSection = obj.currentTarget;
			if(++myCurrSection.colorNum>colorArr.length){
				myCurrSection.colorNum=1;
			}
			var newColorTransform:ColorTransform = myCurrSection.transform.colorTransform;
			newColorTransform.color = colorArr[myCurrSection.colorNum-1];
			myCurrSection.transform.colorTransform = newColorTransform;
		}
		
		private function  buildLine(){
			if(lineMc != null){
				while(lineMc.numChildren){
					lineMc.removeChildAt(0);
				}
			}
			for(var i=1; i<=sectionArr[currSection-1]; i++){
				var myLineShape:Shape = new Shape();
				myLineShape.graphics.clear();
				myLineShape.graphics.lineStyle(1.3, 0x000000, 1);
				myLineShape.graphics.moveTo(beginX, beginY);
				var beginAng = Number(sectionAngArr[i-1].split("_")[0]);
				var ang =  beginAng-90;
				var xMov = beginX+Math.cos(ang*PI)*rad;
				var yMov = beginY+Math.sin(ang*PI)*rad;
				myLineShape.graphics.lineTo(xMov, yMov);
				lineMc.addChild(myLineShape);
			}
		}
		
		private function buildCircle(){
			if(circleMc != null){
				while(circleMc.numChildren){
					circleMc.removeChildAt(0);
				}
			}
			var myCircle:Shape = new Shape();
			myCircle.graphics.clear();
			myCircle.graphics.lineStyle(1.3, 0x000000, 1);
			myCircle.graphics.drawCircle(beginX, beginY, rad);
			/*myCircle.graphics.moveTo(beginX+rad, beginY);
			for(var i=0; i<=360; i++){
				var xMov = beginX+Math.cos(i*PI)*rad;
				var yMov = beginY+Math.sin(i*PI)*rad;
				myCircle.graphics.lineTo(xMov, yMov);
			}*/
			circleMc.addChild(myCircle);
		}
	}
}