﻿package com{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.utils.getDefinitionByName;
	import flash.geom.ColorTransform;
	import flash.display.BlendMode;
	
	public class AreaOfShapes extends MovieClip{
		private var shapesMC:MovieClip;
		private var informShapesMc:MovieClip;
		private var prevClip:MovieClip;
		private var myGridMc:MovieClip;
		private var myColorGridMc:MovieClip;
		private var smallClipXPos:Number = 138.15;
		private var smallClipYPos:Number = 411.25;
		private var shapesXYPosArr:Array = [];
		private var shapeCnt:Number = 0;
		private var cnt:Number = 0;
		private var shapesDelXYPosArr:Array = [];
		private var shapeDelAngleArr:Array = [];
		private var gridCount:Number
		private var columns:Number;
		private var xx:Number= 0;
		private var yy:Number = 0;
		private var gridWidth:Number;
		private var gridHeigth:Number;
		private var startXpos:Number;
		private var startYpos:Number;
		private var dataXml:XML;
		private var lastGridXVal = 0;
		private var lastGridYVal = 0;
		private var colorArr = ["0xED1C24", "0x005FAE", "0x009900"];
		private var colorNum:Number = 1;
		private var shadeSquare:Boolean = false;
		private var informShapeEnab:Boolean = false;
		private var informShapeNum:Number = 0;
		private var currShape;
		
		public function AreaOfShapes(){
			shapesMC = new MovieClip;
			addChild(shapesMC);
			myColorGridMc = new MovieClip;
			addChild(myColorGridMc);
			myGridMc = new MovieClip;
			addChild(myGridMc);
			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.load(new URLRequest("xml/shapes_area.xml"));
			xmlLoader.addEventListener(Event.COMPLETE, fnLoadXML);
		}
		
		private function fnLoadXML(eve:Event):void{
			dataXml = new XML(eve.target.data);
			for(var i:Number = 0; i < dataXml.shapePosition.pos.length(); i++){
				shapesXYPosArr.push(dataXml.shapePosition.pos[i].@XY);//pushing xy position in array
			}
			fnDisplayInformShapes();
			fnDisplaysShapes();
			informShapesMc = new MovieClip;
			addChild(informShapesMc);
			informShapesMc.visible = false;
		}
		
		private function fnDisplayInformShapes(){
			var totImages = dataXml.informShapePosition.pos.length();
			for(var i:Number = 1; i <= totImages; i++){
				var clipClass:Class = getDefinitionByName("informalShape_" + i + "_mc") as Class;
				var clip:MovieClip = new clipClass;
				addChild(clip);
				clip.name = "informShape_" + i + "_mc";
				clip.Num = i;
				//clip.width = clip.width * (90/100);
				//clip.height = clip.height * (90/100);
				clip.visible = false;
				clip.x = Number((dataXml.informShapePosition.pos[i-1].@XY).split("_")[0]);
				clip.y = Number((dataXml.informShapePosition.pos[i-1].@XY).split("_")[1]);
				clip.mouseChildren = false;
				//smallClipXPos = smallClipXPos + clip.width + 8;
				clip.addEventListener(MouseEvent.MOUSE_DOWN, onInformShapeDown);
			}
		}
		
		private function onInformShapeDown(obj:MouseEvent){
			informShapeNum++;
			var myShape:MovieClip;
			if(obj.currentTarget.Num == 1){
				var rndNum = Math.ceil(Math.random()*3);
				trace("rndNum = "+rndNum);
				myShapeMc.gotoAndStop(rndNum);
				myShape = duplicateObject(myShapeMc as MovieClip);
			}else{
				myShape = duplicateObject(obj.target as MovieClip);
			}
			myShape.name = "Shape"+informShapeNum;
			informShapesMc.addChild(myShape);
			currShape = myShape;
			myShape.doubleClickEnabled = true;
			myShape.addEventListener(MouseEvent.DOUBLE_CLICK, removeInfoShape);
			myShape.addEventListener(MouseEvent.MOUSE_DOWN, onShapeDown);
			myShape.addEventListener(MouseEvent.MOUSE_UP, onShapeUp);
			myShape.x = mouseX-(myShape.width/2);
			myShape.y = mouseY-(myShape.height/2);
			myShape.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
		}
		
		private function removeInfoShape(obj:MouseEvent){
			var myShape = obj.currentTarget;
			informShapesMc.removeChild(myShape);
		}
		
		private function onShapeDown(obj:MouseEvent){
			currShape = obj.currentTarget;
			currShape.startDrag(false, new Rectangle(20, 20, 710, 340));
			currShape.parent.stage.addEventListener(MouseEvent.MOUSE_UP, onShapeUp);
		}
		
		private function onShapeUp(obj:MouseEvent){
			currShape.stopDrag();
			currShape.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, onShapeUp);
		}
		
		private function duplicateObject(clone:MovieClip):MovieClip {
			var bmd:BitmapData=new BitmapData(clone.width, (clone.height),true,0x00000000);
			bmd.draw(clone);

			var holder:Bitmap = new Bitmap();
			holder.bitmapData=bmd;
			holder.smoothing=true;
			var obj:MovieClip = new MovieClip();
			obj.addChild(holder);
			return obj;
		}
		
		private function fnDisplaysShapes():void{
			for(var i:Number = 1; i <= 5; i++){
				var clipClass:Class = getDefinitionByName("shape_" + i + "_mc") as Class;
				var clip:MovieClip = new clipClass;
				addChild(clip);
				clip.name = "shape_" + i + "_mc";
				clip.width = clip.width * (90/100);
				clip.height = clip.height * (90/100);
				//clip.x = smallClipXPos + (i-1)*(89.7);
				clip.x = smallClipXPos + (i-1)*(109.7);
				clip.y = smallClipYPos;
				clip.mouseChildren = false;
				//smallClipXPos = smallClipXPos + clip.width + 8;
				clip.addEventListener(MouseEvent.CLICK, fnAddShapeToStage);
			}
			createGrid();
			addListeners();
		}
		
		private function createGrid(){
			columns = 15;
			gridWidth = dataXml.grid.@gridWidth;
			gridHeigth =  dataXml.grid.@gridHeigth;
			createGridCount()
		}
		
		private function createGridCount()
		{
			var beginX = Number(dataXml.grid.count.@xpos);
			var beginY = Number(dataXml.grid.count.@ypos);
			//trace(beginX+"  ---  "+beginY);
			for (var i:int=1; i<=135; i++)
			{						
				var gridMc = new Sprite();
				gridMc.name = "gridMc_"+i;
				//gridMc.graphics.beginFill(dataXml.grid.@bgColor,0);
				gridMc.graphics.lineStyle(2,dataXml.grid.@borderColor)
				var a:Number = ((gridWidth)*xx)
				var b:Number = (gridHeigth*yy)	
				gridMc.graphics.drawRect(0, 0, gridWidth, gridHeigth);
				gridMc.x=beginX+a;
				gridMc.y=beginY+b;
				
				var gridMc1 = new Sprite();
				gridMc1.name = "gridMc_"+i
				gridMc1.graphics.beginFill(dataXml.grid.@bgColor);
				gridMc1.graphics.lineStyle(2,dataXml.grid.@borderColor)
				gridMc1.graphics.drawRect(0, 0, gridWidth, gridHeigth);
				gridMc1.x=beginX+a;
				gridMc1.y=beginY+b;
				gridMc1.alpha = 0;
				gridMc1.addEventListener(MouseEvent.CLICK, onGridSelect);
				
				if (xx<columns-1) {
					xx++;
				} else {
					xx=0;
					yy++;
				}					
				myGridMc.addChild(gridMc);
				myColorGridMc.addChild(gridMc1);
				myGridMc.visible = false;
				myColorGridMc.visible = false;
				lastGridXVal = gridMc.x+gridWidth;
				lastGridYVal = gridMc.y+gridHeigth;
			}
				
		}
		
		private function addListeners(){
			delete_btn.addEventListener(MouseEvent.CLICK, fnDeleteShape);
			clockwise_btn.addEventListener(MouseEvent.CLICK, fnRotateShape);
			anitClockwise_btn.addEventListener(MouseEvent.CLICK, fnRotateShape);
			larger_btn.addEventListener(MouseEvent.CLICK, fnResizeShape);
			smaller_btn.addEventListener(MouseEvent.CLICK, fnResizeShape);
			gridOffBtn.visible = false;
			gridOffBtn.buttonMode = true;
			gridOffBtn.addEventListener(MouseEvent.CLICK, showHideGrid);
			gridOffBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			gridOffBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			gridOnBtn.buttonMode = true;
			gridOnBtn.addEventListener(MouseEvent.CLICK, showHideGrid);
			gridOnBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			gridOnBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			shadeBtn.mouseChildren = false;
			shadeBtn.buttonMode = true;
			shadeBtn.addEventListener(MouseEvent.CLICK, shadeFunc);
			shadeBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			shadeBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			shadeBtn.mouseEnabled = false;
			shadeBtn.alpha = 0.5;
			for(var i=1; i<=3; i++){
				var colBtn = this["colorbtn"+i];
				colBtn.Num = i;
				colBtn.visible = false;
				colBtn.buttonMode = true;
				colBtn.addEventListener(MouseEvent.CLICK, onColorSelect);
				colBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
				colBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			}
			infomeas_btn.mouseChildren = false;
			infomeas_btn.buttonMode = true;
			infomeas_btn.addEventListener(MouseEvent.CLICK, informClick);
			infomeas_btn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			infomeas_btn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			reset_btn.addEventListener(MouseEvent.CLICK, onResetFunc);
		}
		
		private function informClick(obj:MouseEvent){
			if(informShapeEnab==false){
				informShapeEnab = true;
				visibleInformImage(true);
				informShapesMc.visible = true;
			}else{
				informShapeEnab = false;
				visibleInformImage(false);
				informShapesMc.visible = false;
				informShapeNum = 0;
				while(informShapesMc.numChildren){
					informShapesMc.removeChildAt(0);
				}
			}
		}
		
		private function visibleInformImage(valU:Boolean){
			var totImages = dataXml.informShapePosition.pos.length();
			for(var i:Number = 1; i <= totImages; i++){
				var myShape = getChildByName("informShape_"+i+"_mc");
				myShape.visible = valU;
			}
		}
		
		private function onResetFunc(obj:MouseEvent){
			informShapeEnab = false;
			visibleInformImage(false);
			informShapesMc.visible = false;
			informShapeNum = 0;
			while(informShapesMc.numChildren){
				informShapesMc.removeChildAt(0);
			}
			gridOnBtn.visible = true;
			gridOffBtn.visible = false;
			myGridMc.visible = false;
			myColorGridMc.visible = false;
			shadeBtn.mouseEnabled = false;
			shadeBtn.alpha = 0.5;
			visibleColorBtn(false);
			shapeCnt = 0;
			cnt = 0;
			shapesDelXYPosArr = [];
			shapeDelAngleArr = [];
			while(shapesMC.numChildren){
				shapesMC.removeChildAt(0);
			}
		}
		
		private function onBtnOver(obj:MouseEvent){
			obj.currentTarget.gotoAndStop(2);
		}
		
		private function onBtnOut(obj:MouseEvent){
			obj.currentTarget.gotoAndStop(1);
		}
		
		private function onColorSelect(obj:MouseEvent){
			for(var i=1; i<=3; i++){
				var colBtn = this["colorbtn"+i];
				colBtn.mouseEnabled = true;
				colBtn.gotoAndStop(1);
			}
			obj.currentTarget.mouseEnabled = false;
			obj.currentTarget.gotoAndStop(3);
			colorNum = obj.currentTarget.Num;
		}
		
		private function shadeFunc(obj:MouseEvent){
			shadeSquare = true;
			visibleColorBtn(true);
			for (var i:int=1; i<=135; i++)
			{
				var myGrid = myColorGridMc.getChildByName("gridMc_"+i);
				myGrid.alpha = 0;
			}
			myColorGridMc.visible = true;
		}
		
		private function visibleColorBtn(ValU:Boolean){
			for(var i=1; i<=3; i++){
				var colBtn = this["colorbtn"+i];
				colBtn.visible = ValU;
				colBtn.mouseEnabled = ValU;
				colBtn.gotoAndStop(1);
			}
			colBtn = this["colorbtn"+1];
			colBtn.mouseEnabled = false;
			colBtn.gotoAndStop(3);
			colorNum = 1;
		}
		
		private function onGridSelect(obj:MouseEvent){
			var myClip = obj.currentTarget;
			if(myClip.alpha == 0){
				var newColorTransform:ColorTransform = myClip.transform.colorTransform;
				newColorTransform.color = colorArr[colorNum-1];
				myClip.transform.colorTransform = newColorTransform;
				//myClip.alpha = .7;
				myClip.blendMode = BlendMode.DARKEN
				myClip.alpha = 1
			}else{
				myClip.alpha = 0;
			}
		}
		
		private function showHideGrid(obj:MouseEvent){
			if(gridOnBtn.visible == true){
				gridOnBtn.visible = false;
				gridOffBtn.visible = true;
				myGridMc.visible = true;
				shadeBtn.mouseEnabled = true;
				shadeBtn.alpha = 1;
				
			}else{
				gridOnBtn.visible = true;
				gridOffBtn.visible = false;
				myGridMc.visible = false;
				myColorGridMc.visible = false;
				shadeBtn.mouseEnabled = false;
				shadeBtn.alpha = 0.5;
				visibleColorBtn(false);
				shadeSquare = false;
			}
		}
		
		private function fnDeleteShape(eve:MouseEvent):void{
			//if(shadeSquare == false && informShapeEnab == false){
			if(shadeSquare == false){
				if(prevClip != null){
					shapesMC.removeChild(prevClip);
					shapesDelXYPosArr.push(prevClip.x + "_" + prevClip.y);
					shapeDelAngleArr.push(prevClip.rotation);
					prevClip = null;
					shapeCnt--;
				}
			}
		}
		
		private function fnRotateShape(eve:MouseEvent):void{
			//if(shadeSquare == false && informShapeEnab == false){
			if(shadeSquare == false){
				if(prevClip != null){
					var angle:Number = prevClip.rotation;
					if(eve.target.name == "clockwise_btn"){
						prevClip.rotation = angle + 45;
					}else{
						prevClip.rotation = angle - 45;
					}
				}
			}
		}
		
		private function fnResizeShape(eve:MouseEvent):void{
			//if(shadeSquare == false && informShapeEnab == false){
			if(shadeSquare == false){
				if(prevClip != null){
					var refClipClass:Class = getDefinitionByName(prevClip.name.split("##")[0]) as Class;
					var refClip:MovieClip = new refClipClass;
					
					if(eve.target.name == "larger_btn"){
						/*if(prevClip.width <= (refClip.width * (200/100))){
							prevClip.width = prevClip.width * (150/100);
							prevClip.height = prevClip.height * (150/100);
						}*/  
						
						if(prevClip.scaleX <= (refClip.scaleX * (350/100))){
							prevClip.scaleX = prevClip.scaleX * (120/100);
							prevClip.scaleY = prevClip.scaleY * (120/100);
						}
					}else{
						/*if(prevClip.width  > refClip.width){
							prevClip.width = prevClip.width / (150/100);
							prevClip.height = prevClip.height / (150/100);
						}else if(prevClip.width  < refClip.width){
							prevClip.width = refClip.width;
							prevClip.height = refClip.height;
						}*/
						trace(prevClip.scaleX)
						if(prevClip.scaleX  > (refClip.scaleX * (200/100))){
							prevClip.scaleX = prevClip.scaleX / (120/100);
							prevClip.scaleY = prevClip.scaleY / (120/100);
						}
					}
				}
			}
		}
		
		private function fnAddShapeToStage(eve:MouseEvent):void{
			if(prevClip != null){
				prevClip.alpha = 1;
			}
			if(shapeCnt < 12){
				var clipClass:Class = getDefinitionByName(eve.target.name) as Class;
				var clip:MovieClip = new clipClass;
				shapesMC.addChild(clip);
				cnt++;
				clip.name = eve.target.name + "##" + cnt
				if(shapesDelXYPosArr.length == 0){
					clip.x = Number(shapesXYPosArr[shapeCnt].split("_")[0]);
					clip.y = Number(shapesXYPosArr[shapeCnt].split("_")[1]);
				}else{
					clip.x = Number(shapesDelXYPosArr[0].split("_")[0]);
					clip.y = Number(shapesDelXYPosArr[0].split("_")[1]);
					clip.rotation = shapeDelAngleArr[0];
					shapeDelAngleArr.shift();
					shapesDelXYPosArr.shift();
				}
				//mcColorTransform = clip.transform.colorTransform;
				//mcColorTransform.color = color;	
				//clip.bg.transform.colorTransform = mcColorTransform;
				clip.width = clip.width * (260/100);
				clip.height = clip.height * (260/100);
				clip.alpha = .7;
				prevClip = clip;
				clip.addEventListener(MouseEvent.MOUSE_DOWN, fnShapeMouseDown);
				clip.mouseChildren = false;
				shapeCnt++;
			}
		}
		
		private function fnShapeMouseDown(eve:MouseEvent):void{			
			//if(shadeSquare == false && informShapeEnab == false){
			if(shadeSquare == false){
				var clip:MovieClip = eve.target as MovieClip;
				//clip.startDrag(false, new Rectangle(60, 60, 480, 280));
				trace(myGridMc.width+" --- "+clip.width+" ----  "+clip.height);
				clip.startDrag(false, new Rectangle((20+(clip.width/2)), (20+(clip.height/2)), (lastGridXVal-20-(clip.width)), (lastGridYVal-(20+(clip.height)))));
				clip.addEventListener(MouseEvent.MOUSE_UP, fnShapeMouseUp);
			}
		}
		
		private function fnShapeMouseUp(eve:MouseEvent):void{
			//if(shadeSquare == false && informShapeEnab == false){
			if(shadeSquare == false){
				if(prevClip != null){
					prevClip.alpha = 1;
				}
				var clip:MovieClip = eve.target as MovieClip;
				clip.alpha = .7;
				prevClip = clip;
				clip.stopDrag();
				clip.removeEventListener(MouseEvent.MOUSE_UP, fnShapeMouseUp);
			}
		}
		
	}
}