﻿package {
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	import flash.utils.Timer;
	import flash.utils.getDefinitionByName;
    import flash.events.TimerEvent;

	public class PlaceValueDice {
		private var targetClip:MovieClip;
		private var xmlData:XML;
		private var diceCount:Number;
		private var resultArr:Array;
		private var diceArr:Array;
		private var timerCount:Number;
		private var dragObj;
		
		public function PlaceValueDice(target:MovieClip):void {
			targetClip = target;
			targetClip.visible = false;
			xmlData = new XML();
			diceCount = 0;
			diceArr = new Array();
		}
		public function setUp(url:String):void {
			enableBtns(false);
			loadXML(url);
		}		
		private function randomRange(prevRndNum:Number,max:Number, min:Number = 0):Number
		{
			if(max == min) return max;
			var currRnd:Number = Math.round(Math.random() * (max - min) + min);
			var prevRnd:Number = prevRndNum;
			if(prevRnd == currRnd){
				currRnd = randomRange(prevRnd,max,min);
			}	
			return currRnd;
		}				
		private function enableBtns(val:Boolean):void{
			targetClip.reset_btn.enabled = val;
			targetClip.showThousandBtn.enabled = val;
			targetClip.rollBtn.enabled = val;
			targetClip.sixBtn.enabled = val;
			targetClip.tenBtn.enabled = val;
			
			if(val){
				targetClip.reset_btn.addEventListener(MouseEvent.CLICK,function(){reset();});
					
				targetClip.showThousandBtn.visible = (xmlData.@showThousand=="true") ? true : false;
				targetClip.showThousandBtn.buttonMode = true;					
				targetClip.showThousandBtn.gotoAndStop(1);
				targetClip.showThousandBtn.addEventListener(MouseEvent.CLICK,function(){
					if(targetClip.showThousandBtn.currentFrame == 1){
						targetClip.showThousandBtn.gotoAndStop(2);
					}else{
						targetClip.showThousandBtn.gotoAndStop(1);
					}
					showHideThousand();
				});
				
				targetClip.rollBtn.buttonMode = true;
				targetClip.rollBtn.mouseChildren = false;
				targetClip.rollBtn.gotoAndStop(1);
				targetClip.rollBtn.addEventListener(MouseEvent.CLICK,function(){
					
					var dicesClip:MovieClip = targetClip.getChildByName("dicesClip") as MovieClip;
					timerCount = 0;
					for(var i=0;i<diceCount;i++){
						var diceClip:MovieClip = dicesClip.getChildByName("diceClip_"+i) as MovieClip;	
							diceClip.addEventListener(Event.ENTER_FRAME,startAnimation1);
					}
				});
				
				targetClip.sixBtn.buttonMode = true;
				//targetClip.sixBtn.gotoAndStop(1);
				//targetClip.sixBtn.mouseChildren = false;
				//targetClip.sixBtn.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
				//targetClip.sixBtn.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
				//targetClip.sixBtn.addEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
				targetClip.sixBtn.addEventListener(MouseEvent.CLICK,function(){
					targetClip.sixBtn.gotoAndStop(2);
					targetClip.tenBtn.gotoAndStop(1);
					addDice();					
				});
				
				targetClip.tenBtn.buttonMode = true;
				//targetClip.tenBtn.gotoAndStop(2);
				//targetClip.tenBtn.mouseChildren = false;
				//targetClip.tenBtn.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
				//targetClip.tenBtn.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
				//targetClip.tenBtn.addEventListener(MouseEvent.MOUSE_DOWN, onBtnDown);
				targetClip.tenBtn.addEventListener(MouseEvent.CLICK,function(){
					targetClip.sixBtn.gotoAndStop(1);
					targetClip.tenBtn.gotoAndStop(2);
					addDice();					
				});
			}
		}
		private function onBtnOver(obj:MouseEvent){
			var myBtn = obj.currentTarget;
			myBtn.gotoAndStop(2);
		}
		private function onBtnOut(obj:MouseEvent){
			var myBtn = obj.currentTarget;
			myBtn.gotoAndStop(1);
		}
		private function onBtnDown(obj:MouseEvent){
			var myBtn = obj.currentTarget;
			myBtn.gotoAndStop(3);
		}
		private function showHideThousand(){
			diceCount = xmlData.answer.children().length();			
			var answer:MovieClip = targetClip.getChildByName("answer") as MovieClip;
			if(answer!=null){
				var column1:MovieClip = answer.getChildByName("column_0") as MovieClip;
				var column2:MovieClip = answer.getChildByName("column_1") as MovieClip;
				var top:MovieClip = column2.getChildByName("top") as MovieClip;
				var bottom:MovieClip = column2.getChildByName("bottom") as MovieClip;
				var centerX:Number = 0;
				if(targetClip.showThousandBtn.currentFrame == 1){
					column1.visible = false;
					top.border.left.visible = true;
					bottom.border.left.visible = true;
					centerX = (targetClip.boundary.width - answer.width - column1.width)/2
					diceCount = xmlData.answer.children().length() - 1;
				}else{
					column1.visible = true;
					top.border.left.visible = false;
					bottom.border.left.visible = false;
					centerX = (targetClip.boundary.width - answer.width)/2;
				}
				answer.x = (xmlData.answer.@x.toString().length>0) ? Number(xmlData.answer.@x) : centerX;
				answer.y = Number(xmlData.answer.@y);
				addDice();
			}
		}
		private function startAnimation(e:Event):void{
			var id:Number = Number(e.target.parent.name.split("_")[1]);
			var dicesClip:MovieClip = targetClip.getChildByName("dicesClip") as MovieClip;
			var diceClip:MovieClip = dicesClip.getChildByName("diceClip_"+id) as MovieClip;
			diceClip.top.removeEventListener(Event.ENTER_FRAME,startAnimation); 
			var myTimer:Timer = new Timer(100,10);
			myTimer.addEventListener(TimerEvent.TIMER, function(){rollDice(diceClip);});	
			myTimer.addEventListener(TimerEvent.TIMER_COMPLETE,function(){	
				timerCount++;
				if(timerCount == diceCount){
					
				}
			});
			myTimer.start();
		}
		private function startAnimation1(e:Event):void{
			var id:Number = Number(e.target.name.split("_")[1]);
			var dicesClip:MovieClip = targetClip.getChildByName("dicesClip") as MovieClip;
			var diceClip:MovieClip = dicesClip.getChildByName("diceClip_"+id) as MovieClip;
			diceClip.removeEventListener(Event.ENTER_FRAME,startAnimation1); 
			var myTimer:Timer = new Timer(100,10);
			myTimer.addEventListener(TimerEvent.TIMER, function(){rollDice(diceClip);});	
			myTimer.addEventListener(TimerEvent.TIMER_COMPLETE,function(){	
				timerCount++;
				if(timerCount == diceCount){
					
				}
			});
			myTimer.start();
		}
		
		private function rollDice(diceClip:MovieClip):void{	
			var id:Number = Number(diceClip.name.split("_")[1]);
			var len:Number;
			if(targetClip.sixBtn.currentFrame==2){
				len = 5;
			}else{
				len = 9;
			}
			var rolledNum:Number = randomRange(Number(diceArr[id]),0,len);
			rolledNum = rolledNum-1;
			
			trace("rolledNum = "+rolledNum);
			diceArr[id] = rolledNum + 1;
			//diceArr[id] = rolledNum;
			
			var rolledNum1:Number = randomRange(Number(diceArr[id]),0,len);
			rolledNum1 = rolledNum1-1;
			
			var rolledNum2:Number = randomRange(Number(diceArr[id]),0,len);
			rolledNum2 = rolledNum2-1;
			
			drawPageContent(targetClip.sixBtn.currentFrame,rolledNum,diceClip.top);
			drawPageContent(targetClip.sixBtn.currentFrame,rolledNum1,diceClip.left);
			drawPageContent(targetClip.sixBtn.currentFrame,rolledNum2,diceClip.right);
			/*drawPageContent(targetClip.sixBtn.currentFrame,randomRange(Number(diceArr[id]),0,len),diceClip.left);
			drawPageContent(targetClip.sixBtn.currentFrame,randomRange(Number(diceArr[id]),0,len),diceClip.right);*/
		}		
		private function loadXML(path:String) {
			var urlRequest:URLRequest=new URLRequest(path);
			var urlLoader:URLLoader=new URLLoader(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		private function xmlLoaded(e:Event):void {
			xmlData = new XML(e.target.data);
			enableBtns(true);
			drawAnswer();
			reset();			
			targetClip.visible = true;
		}
		public function reset():void {
			addDice();
		}		
		private function resizePage(page:MovieClip, w:Number, h:Number):void {
			page.bg.x=0;
			page.bg.y=0;
			page.bg.width=w;
			page.bg.height=h;			
			//if (page.border.visible) {
				page.border.right.height=h;
				page.border.top.width=w;
				page.border.left.height=h;
				page.border.bottom.width=w;

				page.border.left.x=0;
				page.border.left.y=0;
				page.border.top.x=0;
				page.border.top.y=0;

				page.border.right.x=page.border.top.x+page.border.top.width-page.border.right.width;
				page.border.right.y=0;
				page.border.bottom.x=0;
				page.border.bottom.y=page.border.left.y+page.border.left.height-page.border.bottom.height;
			//}
		}
		private function drawPage(w:Number, h:Number, fillColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip {
			var page:Page = new Page();
			var pageColorTrans:ColorTransform = new ColorTransform();
			pageColorTrans.color=fillColor;
			page.bg.transform.colorTransform=pageColorTrans;
			page.bg.alpha=fillAlpha;
			page.border.visible = (borderSize>0) ? true : false;
			if (page.border.visible) {
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color=borderColor;
				page.border.transform.colorTransform=borderColorTrans;

				page.border.left.width=borderSize;
				page.border.right.width=borderSize;
				page.border.top.height=borderSize;
				page.border.bottom.height=borderSize;
			}
			resizePage(page,w,h);
			return page;
		}
		private function drawDice(fillColor:Number,shadowColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip {
			var diceObj;
			if(targetClip.sixBtn.currentFrame == 2) diceObj = new dice();
			else diceObj = new diamond();
			var diceColorTrans:ColorTransform = new ColorTransform();
			diceColorTrans.color = fillColor;
			diceObj.top.bg.transform.colorTransform = diceColorTrans;
			var shadowColorTrans:ColorTransform = new ColorTransform();
			shadowColorTrans.color = shadowColor;
			diceObj.left.bg.transform.colorTransform = diceObj.right.bg.transform.colorTransform = shadowColorTrans;
			diceObj.top.bg.alpha = diceObj.left.bg.alpha = diceObj.right.bg.alpha = fillAlpha;
			diceObj.top.border.visible = diceObj.left.border.visible = diceObj.right.border.visible = (borderSize>0) ? true : false;
			if (borderSize>0) {
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color=borderColor;
				diceObj.top.border.transform.colorTransform=diceObj.left.border.transform.colorTransform=diceObj.right.border.transform.colorTransform=borderColorTrans;

			}
			return diceObj;
		}
		private function addDice():void {
			if(targetClip.getChildByName("dicesClip")!=null) targetClip.removeChild(targetClip.getChildByName("dicesClip"));
			var dicesClip:MovieClip = new MovieClip(); 
			dicesClip.name = "dicesClip";
			var gap:Number = Number(xmlData.dices.@gap);
			for(var i=0;i<diceCount;i++){
				var diceClip:MovieClip = drawDice(Number(xmlData.dices.dice[i].@bgColor),Number(xmlData.dices.dice[i].@shadowColor), ((xmlData.dices.dice[i].@bgColor=="")?0:1), Number(xmlData.dices.dice[i].@borderSize), Number(xmlData.dices.dice[i].@borderColor));
				diceClip.name="diceClip_"+i;
				diceArr[i] = 0;				
				
				if(targetClip.sixBtn.currentFrame==2){
					if(xmlData.dices.@sixDiceWidth.toString().length>0) diceClip.width = Number(xmlData.dices.@sixDiceWidth);
					if(xmlData.dices.@sixDiceHeight.toString().length>0) diceClip.height = Number(xmlData.dices.@sixDiceHeight);
					drawPageContent(targetClip.sixBtn.currentFrame,4,diceClip.left);
					drawPageContent(targetClip.sixBtn.currentFrame,3,diceClip.right);					
				}else{
					if(xmlData.dices.@tenDiceWidth.toString().length>0) diceClip.width = Number(xmlData.dices.@tenDiceWidth);
					if(xmlData.dices.@tenDiceHeight.toString().length>0) diceClip.height = Number(xmlData.dices.@tenDiceHeight);
					drawPageContent(targetClip.sixBtn.currentFrame,8,diceClip.left);
					drawPageContent(targetClip.sixBtn.currentFrame,6,diceClip.right);					
				}
				drawPageContent(targetClip.sixBtn.currentFrame,0,diceClip.top);
				diceClip.scaleX = 0.7;
				diceClip.scaleY = 0.7;
				diceClip.x = i * (diceClip.width + gap);
				diceClip.y = 0;
				//diceClip.mouseChildren = false;
				diceClip.left.addEventListener(MouseEvent.MOUSE_DOWN, startDiceDrag);
				diceClip.left.addEventListener(MouseEvent.MOUSE_UP, stopDiceDrag);
				diceClip.right.addEventListener(MouseEvent.MOUSE_DOWN, startDiceDrag);
				diceClip.right.addEventListener(MouseEvent.MOUSE_UP, stopDiceDrag);
				diceClip.top.addEventListener(MouseEvent.CLICK, function(e:MouseEvent){
					e.target.addEventListener(Event.ENTER_FRAME,startAnimation);
				});
				dicesClip.addChild(diceClip);
			}
			dicesClip.x = (xmlData.dices.@x.toString().length>0) ? Number(xmlData.dices.@x) : ((targetClip.boundary.width - dicesClip.width)/2);
			dicesClip.y = Number(xmlData.dices.@y);
			targetClip.addChild(dicesClip);
		}
		
		private function startDiceDrag(obj:MouseEvent){
			var id:Number = Number(obj.target.parent.name.split("_")[1]);
			var dicesClip:MovieClip = targetClip.getChildByName("dicesClip") as MovieClip;
			dragObj = dicesClip.getChildByName("diceClip_"+id) as MovieClip;
			dragObj.startDrag(false, new Rectangle((-40-dicesClip.x), (0-dicesClip.y), 670, 270));
			dragObj.parent.stage.addEventListener(MouseEvent.MOUSE_UP, stopDiceDrag);
		}
		
		private function stopDiceDrag(obj:MouseEvent){
			dragObj.stopDrag();
			dragObj.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, stopDiceDrag);
		}
		
		private function changeFormat(targetTxt:TextField,font:String,fontSize:Number,fontColor:uint,align:String=null):void{
			trace("ffff = "+font);
			var txt:TextField = targetTxt;
			var f=getDefinitionByName(font) as Class;
			var fnt=new f();
			
			var txtFormat:TextFormat = new TextFormat();
			txtFormat.leftMargin = 0;
			txtFormat.rightMargin = 0;
			txtFormat.font = fnt.fontName;
			txtFormat.bold = true;			
			txtFormat.size = fontSize;
			txtFormat.color = fontColor;
			if(align!=null) txtFormat.align = align;
			txt.setTextFormat(txtFormat);
			txt.embedFonts=true;
		}
		private function addTxt(txtStr:String):TextField{
			var txt:TextField = new TextField();
			txt.selectable = false;
			txt.background = false;
			txt.border = false;
			txt.autoSize = TextFieldAutoSize.LEFT;
			txt.text = txtStr;
			return txt;
		}
		private function drawPageContent(cType:Number,pageNo:Number,targetPage:MovieClip):void {
			var parentClip:MovieClip = targetPage.parent as MovieClip;
			var pageCont:MovieClip = targetPage.getChildByName("pageCont") as MovieClip;
			if(pageCont!=null) targetPage.removeChild(pageCont);
			pageCont = new MovieClip();
			pageCont.name="pageCont";			
			if (cType==1) {
				var txt:TextField = addTxt((pageNo+1).toString());
				txt.name="txt";				
				if(targetPage.name != "top"){
					changeFormat(txt,xmlData.contents.@font,Number(xmlData.contents.@fontSize)/2,uint(xmlData.contents.@fontColor));
					txt.embedFonts = true;
					if(targetPage.name == "left"){
						pageCont.x = 45 - txt.width/2;
						pageCont.y = 40;					
						pageCont.rotation = 30;
						if(Number(txt.text) < 10){
							pageCont.x = 45 - txt.width/2 + 5;
							pageCont.y = 45;
						}else{
							pageCont.x = 45 - txt.width/2;
							pageCont.y = 40;
						}
					}else{
						if(Number(txt.text) < 10){
							pageCont.x = 55;
							pageCont.y = 60;
						}else{
							pageCont.x = 68;
							pageCont.y = 65;
						}
						pageCont.scaleX *= -1;
						pageCont.rotation = 30;						
					}					
				}else{
					changeFormat(txt,xmlData.contents.@font,Number(xmlData.contents.@fontSize),uint(xmlData.contents.@fontColor));
					pageCont.x = (targetPage.width - pageCont.width - txt.width)/2;
					pageCont.y = (targetPage.height - pageCont.height - txt.height)/2 + 10;
				}
				pageCont.addChild(txt);
			} else {
				var numOfContents:Number=xmlData.contents.content[pageNo].child(targetPage.name).children().length();
				
				if (numOfContents>0) {
					for (var j:Number=0; j<numOfContents; j++) {
						var cont:MovieClip = new MovieClip();
						cont.name="cont_"+j;
						
						cont.graphics.lineStyle(Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@borderSize), Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@borderColor), (Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@borderSize)==0)?0:1);
						cont.graphics.beginFill(Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@bgColor), 1);
						cont.graphics.drawEllipse(0,0,Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@width),Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@height));
						var xDist:Number=Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@x);
						var yDist:Number=Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@y);
						cont.x = xDist;
						cont.y = yDist;
						cont.rotation = (xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@rotation.toString().length>0) ? Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@rotation) : 0;
									
						pageCont.addChild(cont);

					}
					pageCont.x = 0;
					pageCont.y = 0;
				}
			}			
			targetPage.addChild(pageCont);
			targetPage.mouseChildren=false;
		}		
		private function drawAnswer():void{
			var answer:MovieClip = new MovieClip();
			answer.name = "answer";
			var totalColumn:Number = xmlData.answer.children().length();
			for(var i=0;i<totalColumn;i++){				
				var column:MovieClip = new MovieClip();
				column.name = "column_"+i;
				var top:MovieClip = drawPage(Number(xmlData.answer.column[i].top.@width), Number(xmlData.answer.column[i].top.@height), Number(xmlData.answer.column[i].top.@bgColor), ((xmlData.answer.column[i].top.@bgColor=="")?0:1), Number(xmlData.answer.column[i].top.@borderSize), Number(xmlData.answer.column[i].top.@borderColor));
				top.name = "top";
				var txt:TextField = addTxt(xmlData.answer.column[i].@value);
				txt.name="txt";
				changeFormat(txt,xmlData.answer.column[i].@font,Number(xmlData.answer.column[i].@fontSize),uint(xmlData.answer.column[i].@fontColor));
				txt.x = (top.width - txt.width)/2;
				txt.y = (top.height - txt.height)/2;
				top.addChild(txt);
				if(i>0) top.border.left.visible = false;
				column.addChild(top);
				
				var bottom:MovieClip = drawPage(Number(xmlData.answer.column[i].bottom.@width), Number(xmlData.answer.column[i].bottom.@height), Number(xmlData.answer.column[i].bottom.@bgColor), ((xmlData.answer.column[i].bottom.@bgColor=="")?0:1), Number(xmlData.answer.column[i].bottom.@borderSize), Number(xmlData.answer.column[i].bottom.@borderColor));
				bottom.name = "bottom";
				if(i>0) bottom.border.left.visible = false;
				bottom.border.top.visible = false;
				bottom.x = top.x;
				bottom.y = top.y + top.height;
				column.addChild(bottom);
				
				column.x = i * column.width;
				answer.addChild(column);
			}			
			targetClip.addChild(answer);
			showHideThousand();
		}
	}
}