﻿package
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.utils.getDefinitionByName;
	import flash.geom.Rectangle;
	import flash.geom.ColorTransform;
	import fl.transitions.Tween;
	import fl.transitions.easing.*;
	import fl.transitions.TweenEvent;
	import flash.utils.Timer;
    import flash.events.TimerEvent;
	import com.yahoo.astra.fl.managers.AlertManager;
	
	public class SpikeAbacus{
		private var targetClip:MovieClip;
		private var xmlData:XML;
		private var ownNum:Number;
		private var beadsArr:Array;
		private var beadsRemovedArr:Array;
		private var beads1Arr:Array;
		private var beads2Arr:Array;
		private var beads1RemovedArr:Array;
		private var beads2RemovedArr:Array;
		private var ownNum1:Number;
		private var ownNum2:Number;
		private var btnArr:Array;
		private var isDragging:Boolean;
		private var displayTotal1:Boolean = false;
		private var displayTotal2:Boolean = false;
		private var randNumber1:Number = 0;
		private var randNumber2:Number = 0;
		private var thousandView1:Boolean = true
		private var thousandView2:Boolean = true
		private var myhideBg;
		private var countNumber1:Number = 0;
		private var countNumber2:Number = 0;
		
		public function SpikeAbacus(target:MovieClip):void{
			targetClip = target;
			targetClip.visible = false;
			xmlData = new XML();
			ownNum = 0;
			ownNum1 = 0;
			ownNum2 = 0;
			beadsArr = new Array();
			beadsRemovedArr = new Array();
			beads1Arr = new Array();
			beads1RemovedArr = new Array();
			beads2Arr = new Array();
			beads2RemovedArr = new Array();
		}
		
		public function setUp(url:String):void{
			//enableBtns(false);
			loadXML(url);
		}		
		
		private function enableBtns(val:Boolean):void{
			targetClip.showThousandBtn.enabled = val;
			targetClip.hideThousandBtn.enabled = val;
			targetClip.showNumBtn.enabled = val;
			targetClip.hideNumBtn.enabled = val;
			
			targetClip.showThousandBtn.gotoAndStop(1);
			targetClip.hideThousandBtn.gotoAndStop(1);
			targetClip.showNumBtn.gotoAndStop(1);
			targetClip.hideNumBtn.gotoAndStop(1);
			if(val){
				btnArr = [];
				btnArr.push(targetClip.showThousandBtn);
				btnArr.push(targetClip.hideThousandBtn);
				btnArr.push(targetClip.showNumBtn);
				btnArr.push(targetClip.hideNumBtn);
				
				targetClip.showThousandBtn.visible = (xmlData.@showThousand=="true") ? true : false;
				targetClip.hideThousandBtn.visible = (xmlData.@showThousand=="true") ? true : false;
				
				targetClip.showNumBtn.buttonMode = true;
				targetClip.showNumBtn.addEventListener(MouseEvent.CLICK,function(){
					var answer:MovieClip = targetClip.getChildByName("answer") as MovieClip;
					answer.visible = true;
					targetClip.showNumBtn.visible = false;
					targetClip.hideNumBtn.visible = true;
				});
				targetClip.hideNumBtn.buttonMode = true;
				targetClip.hideNumBtn.addEventListener(MouseEvent.CLICK,function(){
					var answer:MovieClip = targetClip.getChildByName("answer") as MovieClip;
					answer.visible = false;
					targetClip.showNumBtn.visible = true;
					targetClip.hideNumBtn.visible = false;
				});
				targetClip.showThousandBtn.buttonMode = true;
				targetClip.showThousandBtn.addEventListener(MouseEvent.CLICK, function() {
					
					//showHideThousandBtn();
					targetClip.showThousandBtn.visible = false;
					targetClip.hideThousandBtn.visible = true;
				});
				targetClip.hideThousandBtn.buttonMode = true;
				targetClip.hideThousandBtn.addEventListener(MouseEvent.CLICK,function(){
 				   	//clearBeads(0);
					//countBeads();
					//showHideThousandBtn();
					targetClip.showThousandBtn.visible = true;
					targetClip.hideThousandBtn.visible = false;
				});
				targetClip.reset_btn.addEventListener(MouseEvent.CLICK,function(){
					reset();
				});
				targetClip.showThousandBtn.visible = false;
				targetClip.hideNumBtn.visible = false;
			}
		}
		
		private function showHideThousandBtn(Num:Number):void {
			
			var thousandBar:MovieClip = targetClip.getChildByName("bar_"+Num+"_"+0) as MovieClip;
			thousandBar.visible = !thousandBar.visible;
			var hundredBar:MovieClip = targetClip.getChildByName("bar_"+Num+"_"+1) as MovieClip;
			hundredBar.bg.start.visible = !thousandBar.visible;
			hundredBar.bg.start.x = hundredBar.bg.middle.x - hundredBar.bg.start.width;
			var thousandLine:MovieClip = targetClip.getChildByName("spike_"+Num+"_"+0) as MovieClip;
			thousandLine.visible = thousandBar.visible;
			this["thousandView" + Num] = !this["thousandView" + Num]
			
		}
		
		private function loadXML(path:String){
			var urlRequest:URLRequest = new URLRequest(path);
			var urlLoader:URLLoader = new URLLoader(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		
		private function xmlLoaded(e:Event):void{
			xmlData = new XML(e.target.data);
			beadsArr = [];			
			beads1Arr = [];
			beads2Arr = [];
			//enableBtns(true);	
			targetClip.preventAnimation.visible = false
			addLines();
			addDraggableBead();
			//addResult();
			//var myBg = getDefinitionByName("myhideBg") as Class;
			myhideBg = new hideBg();
			myhideBg.x = 388.6;
			myhideBg.y = 9.3;
			targetClip.addChild(myhideBg);
			myhideBg.visible = false;
			addBtnListeners();
			//reset();			
			targetClip.visible = true;
			
		}		
		
		private function addBtnListeners(){
			for(var i=1; i<=2; i++){
				var hideThousandBtn = targetClip.getChildByName("hideThousandBtn"+i);
				hideThousandBtn.Num = i;
				hideThousandBtn.buttonMode = true;
				hideThousandBtn.mouseChildren = false;
				hideThousandBtn.addEventListener(MouseEvent.CLICK, onHideThousandFunc);
				var showThousandBtn = targetClip.getChildByName("showThousandBtn"+i);
				showThousandBtn.Num = i;
				showThousandBtn.buttonMode = true;
				showThousandBtn.mouseChildren = false;
				showThousandBtn.addEventListener(MouseEvent.CLICK, onShowThousandFunc);
				hideThousandBtn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
				var dispTotalBtn = targetClip.getChildByName("dispTotalBtn"+i);
				dispTotalBtn.Num = i;
				dispTotalBtn.buttonMode = true;
				dispTotalBtn.mouseChildren = false;
				dispTotalBtn.addEventListener(MouseEvent.CLICK, onDispTotalFunc);
				var typeTotalBtn = targetClip.getChildByName("typeTotalBtn"+i);
				typeTotalBtn.Num = i;
				typeTotalBtn.buttonMode = true;
				typeTotalBtn.mouseChildren = false;
				typeTotalBtn.addEventListener(MouseEvent.CLICK, onTypeTotalFunc);
				typeTotalBtn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
				var randNumBtn = targetClip.getChildByName("randNumBtn"+i);
				randNumBtn.Num = i;
				randNumBtn.buttonMode = true;
				randNumBtn.mouseChildren = false;
				randNumBtn.addEventListener(MouseEvent.CLICK, showRandomFunc);
			}
			var hide2ndAbacus = targetClip.getChildByName("hide2ndAbacusBtn");
			hide2ndAbacus.buttonMode = true;
			hide2ndAbacus.mouseChildren = false;
			hide2ndAbacus.addEventListener(MouseEvent.CLICK, hide2ndAbacusFunc);
			var show2ndAbacus = targetClip.getChildByName("show2ndAbacusBtn");
			show2ndAbacus.buttonMode = true;
			show2ndAbacus.mouseChildren = false;
			show2ndAbacus.addEventListener(MouseEvent.CLICK, show2ndAbacusFunc);
			hide2ndAbacus.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			targetClip.reset_btn.addEventListener(MouseEvent.CLICK,function(){
					reset();
				});
		}
		
		private function hide2ndAbacusFunc(obj:MouseEvent){
			var numOfLines:Number = xmlData.lines.children().length();
			for(var i=0;i<numOfLines;i++){
				clearBeads(2, i);
			}
			myhideBg.parent.setChildIndex(myhideBg, myhideBg.parent.numChildren-1);
			myhideBg.visible = true;
			var show2ndAbacus = targetClip.getChildByName("show2ndAbacusBtn");
			show2ndAbacus.visible = true;
			obj.currentTarget.visible = false;
		}
		
		private function show2ndAbacusFunc(obj:MouseEvent){
			myhideBg.visible = false;
			var hide2ndAbacus = targetClip.getChildByName("hide2ndAbacusBtn");
			hide2ndAbacus.visible = true;
			obj.currentTarget.visible = false;
		}
		
		private function showRandomFunc(obj:MouseEvent){
			var barId = obj.currentTarget.Num;
			var showThouBtn = targetClip.getChildByName("showThousandBtn"+barId);
			if(showThouBtn.visible == true){
				this["randNumber"+barId] = Math.ceil(Math.random()*999);
			}else{
				this["randNumber"+barId] = Math.ceil(Math.random()*9999);
			}
			var numOfLines:Number = xmlData.lines.children().length();
			for(var i=0;i<numOfLines;i++){
				clearBeads(barId, i);
			}
			//this["beads"+barId+"Arr"] = [];
			//this["beads"+barId+"RemovedArr"] = [];
			var numArr = String(this["randNumber"+barId]).split("");
			//trace("randNo = "+this["randNumber"+barId]+"  -- "+numArr.length);
			var totSpike = 4;
			for(i=numArr.length; i>=1; i--){
				//trace("barId = "+barId+" --  "+Number(numArr[i-1]));
				for(var j=1; j<=Number(numArr[i-1]); j++){
					addBead(barId, Number(totSpike-1));
				}
				totSpike--;
			}
			countBeads(barId);
		}
		
		private function onDispTotalFunc(obj:MouseEvent){
			var barId = obj.currentTarget.Num;
			this["displayTotal"+barId] = true;
			var myAnswerBox = targetClip.getChildByName("answerBox"+barId);
			var myTextBox = myAnswerBox.getChildByName("inputTxt");
			myTextBox.text = "";
			myTextBox.selectable = false;
			myTextBox.type = TextFieldType.DYNAMIC;
			countBeads(barId);
			var typeTotalBtn = targetClip.getChildByName("typeTotalBtn"+barId);
			typeTotalBtn.mouseEnabled = true;
			obj.currentTarget.mouseEnabled = false;
		}
		
		private function onTypeTotalFunc(obj:MouseEvent){
			var barId = obj.currentTarget.Num;
			this["displayTotal"+barId] = false;
			var myAnswerBox = targetClip.getChildByName("answerBox"+barId);
			var myTextBox = myAnswerBox.getChildByName("inputTxt");
			myTextBox.text = "";
			myTextBox.selectable = true;
			myTextBox.type = TextFieldType.INPUT;
			var dispTotalBtn = targetClip.getChildByName("dispTotalBtn"+barId);
			dispTotalBtn.mouseEnabled = true;
			obj.currentTarget.mouseEnabled = false;
		}
		
		private function onShowThousandFunc(obj:MouseEvent){
			showHideThousandBtn(obj.currentTarget.Num);
			
			obj.currentTarget.visible = false;
			var hideThouBtn = targetClip.getChildByName("hideThousandBtn"+obj.currentTarget.Num);
			hideThouBtn.visible = true;
		}
		
		private function onHideThousandFunc(obj:MouseEvent){
			clearBeads(obj.currentTarget.Num, 0);
			showHideThousandBtn(obj.currentTarget.Num);
			var showThouBtn = targetClip.getChildByName("showThousandBtn"+obj.currentTarget.Num);
			showThouBtn.visible = true;
			obj.currentTarget.visible = false;
		}
		
		private function reset():void{
			ownNum1 = 0;
			ownNum2 = 0;
			isDragging = false;
			
			var numOfLines:Number = xmlData.lines.children().length();
			for(var j=1; j<=2; j++){
				for(var i=0;i<numOfLines;i++){
					clearBeads(j, i);
				}
			}
			var hide2ndAbacus = targetClip.getChildByName("hide2ndAbacusBtn");
			hide2ndAbacus.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			for(i=1; i<=2; i++){
				var hideThousandBtn = targetClip.getChildByName("hideThousandBtn"+i);
				hideThousandBtn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
				var typeTotalBtn = targetClip.getChildByName("typeTotalBtn"+i);
				typeTotalBtn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
				
				var thousandBar:MovieClip = targetClip.getChildByName("bar_"+i+"_"+0) as MovieClip;
				thousandBar.visible = false;
				var hundredBar:MovieClip = targetClip.getChildByName("bar_"+i+"_"+1) as MovieClip;
				hundredBar.bg.start.visible = true;
				hundredBar.bg.start.x = hundredBar.bg.middle.x - hundredBar.bg.start.width;
				var thousandLine:MovieClip = targetClip.getChildByName("spike_"+i+"_"+0) as MovieClip;
				thousandLine.visible = false;
			}
			
			//countBeads();
		}
		
		private function changeFormat(targetTxt:TextField,font:String,fontSize:Number,fontColor:uint,align:String=null):void{
			var txt:TextField = targetTxt;
			var f=getDefinitionByName(font) as Class;
			var fnt=new f();
			
			var txtFormat:TextFormat = new TextFormat();
			txtFormat.leftMargin = 0;
			txtFormat.rightMargin = 0;
			//txtFormat.font = font;
			txtFormat.font = fnt.fontName;
			txtFormat.bold = true;			
			txtFormat.size = fontSize;
			txtFormat.color = fontColor;
			if(align!=null) txtFormat.align = align;
			txt.setTextFormat(txtFormat);
			txt.embedFonts=true;
		}
		
		private function resizePage(page:MovieClip, w:Number, h:Number):void {
			page.bg.x=0;
			page.bg.y=0;
			page.bg.width=w;
			page.bg.height=h;
			
			//if (page.border.visible) {
				page.border.right.height=h;
				page.border.top.width=w;
				page.border.left.height=h;
				page.border.bottom.width=w;

				page.border.left.x=0;
				page.border.left.y=0;
				page.border.top.x=0;
				page.border.top.y=0;

				page.border.right.x=page.border.top.x+page.border.top.width-page.border.right.width;
				page.border.right.y=0;
				page.border.bottom.x=0;
				page.border.bottom.y=page.border.left.y+page.border.left.height-page.border.bottom.height;
			//}
		}
		
		private function drawPage(w:Number, h:Number, fillColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip {
			var page:Page = new Page();
			var pageColorTrans:ColorTransform = new ColorTransform();
			pageColorTrans.color=fillColor;
			page.bg.transform.colorTransform=pageColorTrans;
			page.bg.alpha=fillAlpha;
			page.border.visible = (borderSize>0) ? true : false;
			if (page.border.visible) {
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color=borderColor;
				page.border.transform.colorTransform=borderColorTrans;

				page.border.left.width=borderSize;
				page.border.right.width=borderSize;
				page.border.top.height=borderSize;
				page.border.bottom.height=borderSize;
			}
			resizePage(page,w,h);
			return page;
		}
		
		private function drawBead(target:MovieClip):void{
			var bead:Bead = new Bead();
			bead.width = Number(xmlData.bead.@width);
			bead.height = Number(xmlData.bead.@height);
			bead.Num = target.Num;
			target.mouseChildren = false;
			target.addChild(bead);			
		}
		
		private function addLines():void{
			var numOfLines:Number = xmlData.lines.children().length();
			for(var j=1; j<=2; j++){
				var startVal = ((j-1)*380);
				for(var i=0; i<numOfLines; i++){
					var bar:Bar = new Bar();
					bar.name = "bar_"+j+"_"+i;
					bar.Num = j;
					var txt:TextField = addTxt("txt",xmlData.lines.line[i].@label);
				
					if(xmlData.label.@align.toString().length>0)
					changeFormat(txt,xmlData.label.@font,Number(xmlData.label.@fontSize),uint(xmlData.label.@fontColor),xmlData.label.@align);
					else
					changeFormat(txt,xmlData.label.@font,Number(xmlData.label.@fontSize),uint(xmlData.label.@fontColor));
				
					bar.addChild(txt);
					var spike:Spike = new Spike();
					spike.name = "spike_"+j+"_"+i;
					var w:Number = Number(xmlData.lines.@width);
					var prevLine:MovieClip = targetClip.getChildByName("bar_"+j+"_"+(i-1)) as MovieClip;
					if(numOfLines>1){
						if(i==0){
							bar.bg.start.visible = true;
							bar.bg.end.visible = false;
							bar.bg.middle.width = (w - bar.bg.start.width);
						}else if(i==numOfLines-1){
							bar.bg.start.visible = false;
							bar.bg.end.visible = true;
							bar.bg.middle.width = (w - bar.bg.start.width);
						}else{
							bar.bg.start.visible = false;
							bar.bg.end.visible = false;
							bar.bg.middle.width = w;
						}
					}else{
						bar.bg.start.visible = true;
						bar.bg.end.visible = true;
					}
				
					bar.bg.start.x = 0;
					bar.bg.middle.x = (bar.bg.start.visible) ? bar.bg.start.x + bar.bg.start.width : 0;
					bar.bg.end.x = (bar.bg.end.visible) ? bar.bg.middle.x + bar.bg.middle.width : 0;
					txt.width = bar.bg.width;
					txt.wordWrap = true;
					txt.x = bar.bg.x + (bar.bg.width - txt.width)/2;
					txt.y = (bar.bg.height - txt.height)/2 + 3;
					if(prevLine!= null){
						//trace(prevLine.x+" prev = "+prevLine.width);
					}
					bar.x = ((prevLine!=null) ? ((prevLine.x + prevLine.width)) : (Number(xmlData.lines.@x)+(startVal)));
					bar.y = Number(xmlData.lines.@y);
					//trace(bar.x+" xy = "+bar.y+" wid = "+bar.width);
					spike.x = bar.x + (bar.width - spike.width)/2;
					spike.y = bar.y - spike.height + 5;				
					targetClip.addChild(bar);
					targetClip.addChild(spike);
					/*beadsArr[i] = [];
					beadsRemovedArr[i] = [];*/
					this["beads"+j+"Arr"][i] = [];
					this["beads"+j+"RemovedArr"][i] = [];
				}			
			}
			targetClip.addEventListener(MouseEvent.MOUSE_UP,onStageClicked);
			
		}
		
		private function addDraggableBead():void{
			for(var j=1; j<=2; j++){
				var dragBead:MovieClip = new MovieClip();
				dragBead.name = "dragBead"+j;
				dragBead.Num = j;
				drawBead(dragBead);
				dragBead.x = Number(xmlData.bead.@x)+((j-1)*380);
				dragBead.y = Number(xmlData.bead.@y);			
				dragBead.addEventListener(MouseEvent.MOUSE_DOWN,makeDuplicate);
				targetClip.addChild(dragBead);
			}
			targetClip.setChildIndex(targetClip.preventAnimation, targetClip.numChildren - 1);
			
		}		
		
		private function addBead(barId:Number, spikeId:Number):void{
			var beadArr:Array = (this["beads"+barId+"Arr"][spikeId]!=null) ? this["beads"+barId+"Arr"][spikeId] : [];
			var beadRemovedArr:Array = (this["beads"+barId+"RemovedArr"][spikeId]!=null) ? this["beads"+barId+"RemovedArr"][spikeId] : [];
			var beadId:Number = (beadRemovedArr.length > 0) ? Number(beadRemovedArr[0].split("_")[3]) : beadArr.length;
			trace(beadId,beadRemovedArr)
			var bead:MovieClip = new MovieClip();
			bead.name = "bead_"+barId+"_"+spikeId+"_"+beadId;					
			drawBead(bead);
			
			bead.addEventListener(MouseEvent.CLICK,onBeadClicked);
			targetClip.addChild(bead);	
			beadArr.push(bead.name);
			
			beadRemovedArr.splice(0,1);
			this["beads"+barId+"Arr"][spikeId] = beadArr;
			this["beads"+barId+"RemovedArr"][spikeId] = beadRemovedArr;
			arrangeBeads(barId, spikeId);
		}
		
		private function addTxt(name:String,txtStr:String):TextField{
			var txt:TextField = new TextField();
			txt.name = name;
			txt.selectable = false;
			txt.background = false;
			txt.border = false;
			txt.autoSize = TextFieldAutoSize.LEFT;
			txt.text = txtStr;
			return txt;
		}		
		
		private function addResult():void{
			var answer:MovieClip = drawPage(Number(xmlData.answer.@width), Number(xmlData.answer.@height), Number(xmlData.answer.@bgColor), ((xmlData.answer.@bgColor=="")?0:1), Number(xmlData.answer.@borderSize), Number(xmlData.answer.@borderColor));
			answer.name = "answer";
			answer.visible = false;
			var txt:TextField = addTxt("txt",ownNum.toString());
			answer.addChild(txt);			
			answer.x = xmlData.answer.@x;
			answer.y = xmlData.answer.@y;
			targetClip.addChild(answer);
		}
		
		private function onStageClicked(e:MouseEvent):void{
			if(e.target.name!="dupBead") return;
			var numOfLines:Number=xmlData.lines.children().length();
			//
			var currentlocalCount = 0
			for (var i = 1; i <= 2; i++) {
				
				for (var j:Number=0; j<numOfLines; j++) {
					var spike:MovieClip = targetClip.getChildByName("spike_"+i+"_"+j) as MovieClip;
					var dupBead:MovieClip = targetClip.getChildByName("dupBead") as MovieClip;
					
					if((targetClip.mouseX >=spike.x && targetClip.mouseX <=spike.x+spike.width) && (targetClip.mouseY >=spike.y && targetClip.mouseY <=spike.y+spike.height) && (dupBead.Num==i)){					
						//var dupBead:MovieClip = targetClip.getChildByName("dupBead") as MovieClip;
						targetClip.removeChild(dupBead);
						//trace("ganesh = "+dupBead.Num);
						var spikeId:Number = Number(spike.name.split("_")[2]);	
						//trace(spikeId)
						var barId:Number = Number(spike.name.split("_")[1]);
						var beadArr:Array = (this["beads"+barId+"Arr"][spikeId]!=null) ? this["beads"+barId+"Arr"][spikeId] : [];
						isDragging = false;						
						currentlocalCount = Number(xmlData.lines.line[j].@value) + this["countNumber" + barId]
						var targetValue:Number
						if (!this["thousandView" + i])
						{
							targetValue = 999
						}else
						{
							targetValue = 9999
						}
						
						
						if(currentlocalCount>targetValue){
							//trace("This abacus can only display numbers to 9 999");
							AlertManager.createAlert(targetClip, "This abacus can only display numbers to 9 "+targetValue);
							return;
						}else if(spikeId==1 && beadArr.length>8 && targetClip.showThousandBtn.visible){
							//AlertManager.createAlert(targetClip, "This abacus can only display numbers to 999");
							//return;
						}else if(spikeId==2 && beadArr.length>8 && targetClip.showThousandBtn.visible){
							/*AlertManager.createAlert(targetClip, "This abacus can only display numbers to 999");
							return;*/
						}else if(spikeId==3 && beadArr.length>8 && targetClip.showThousandBtn.visible){
							/*AlertManager.createAlert(targetClip, "This abacus can only display numbers to 999");
							return;*/
						}else if(spikeId==1 && beadArr.length>8 && !targetClip.showThousandBtn.visible){
							/*AlertManager.createAlert(targetClip, "This abacus can only display numbers to 9 999");
							return;*/
						}else if(spikeId==2 && beadArr.length>8 && !targetClip.showThousandBtn.visible){
							/*AlertManager.createAlert(targetClip, "This abacus can only display numbers to 9 999");
							return;*/
						}else if(spikeId==3 && beadArr.length>8 && !targetClip.showThousandBtn.visible){
							/*AlertManager.createAlert(targetClip, "This abacus can only display numbers to 9 999");
							return;*/
						}
						if (!this["thousandView" + i])
						{
							if (spikeId != 0)
							{
								addBead(barId, spikeId);					
							}
						}else
						{
							addBead(barId, spikeId);
						}
						
						break;
					}
				}
			}
			/*for(i=0;i<btnArr.length;i++){
				var btn:MovieClip = btnArr[i] as MovieClip;
				if(btn.visible && (targetClip.mouseX >=btn.x && targetClip.mouseX <=btn.x+btn.width) && (targetClip.mouseY >=btn.y && targetClip.mouseY <=btn.y+btn.height)){
					btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
					break;
				}
			}	*/		
		}
		
		private function onBeadClicked(e:MouseEvent):void{
			var bead:MovieClip = targetClip.getChildByName(e.target.name) as MovieClip;
			var spikeId:Number = Number(e.target.name.split("_")[2]);
			var barId:Number = Number(e.target.name.split("_")[1]);
			
			targetClip.removeChild(bead);
			var beadArr:Array = this["beads"+barId+"Arr"][spikeId];
			
			var beadRemovedArr:Array = this["beads"+barId+"RemovedArr"][spikeId];			
			for(var i=0;i<beadArr.length;i++){
				if(beadArr[i] == bead.name){
					beadArr.splice(i,1);
					beadRemovedArr.push(bead.name);
				}
			}			
			this["beads"+barId+"Arr"][spikeId] = beadArr;
			this["beads"+barId+"RemovedArr"][spikeId] = (beadArr.length>0) ? beadRemovedArr : [];
			arrangeBeads(barId,spikeId);
		}	
		
		private function makeDuplicate(e:MouseEvent):void{
			if(!isDragging){
				var dupBead:MovieClip = new MovieClip();
				dupBead.name="dupBead";
				dupBead.Num = e.currentTarget.Num;
				drawBead(dupBead);
				dupBead.x = targetClip.mouseX - dupBead.width/2;
				dupBead.y = targetClip.mouseY - dupBead.height/2;
				targetClip.addChild(dupBead);
				var boundary:Rectangle=new Rectangle(targetClip.boundary.x,targetClip.boundary.y,targetClip.boundary.width-dupBead.width,targetClip.boundary.height-dupBead.height);
				dupBead.startDrag(false,boundary);
				isDragging = true;
			}
		}
		
		private function arrangeBeads(barId:Number, spikeId:Number):void {
			
			
			var arr:Array = this["beads"+barId+"Arr"][spikeId];
			var spike:MovieClip = targetClip.getChildByName("spike_"+barId+"_"+spikeId) as MovieClip;	
			for(var i=0;i<arr.length;i++){				
				if(arr[i-1] != undefined)
				var prevBead:MovieClip = targetClip.getChildByName(arr[i - 1]) as MovieClip;
				
				var bead:MovieClip = targetClip.getChildByName(arr[i]) as MovieClip;
				bead.x = spike.x + (spike.width - bead.width)/2;
				bead.y = (prevBead != null) ? prevBead.y - prevBead.height : spike.y + spike.height - bead.height;	
				
				
			}
			targetClip.preventAnimation.visible = false
			countBeads(barId);
		}
		
		private function countBeads(barId:Number):void{
			this["ownNum"+barId] = 0;
			var localCount:Number = 0;
			var numOfLines:Number = xmlData.lines.children().length();
			//trace("numOfLines", numOfLines);
			var count = 0
			var amnimtion = false
			
			for (var l = numOfLines-1; l >= 0; l--) {
				//trace(localCount, Number(xmlData.lines.line[count].@value), 1)
				count++
				localCount = this["beads" + barId + "Arr"][l].length * Number(xmlData.lines.line[l].@value);	
				//trace(localCount)
				if(l!=0){
					if(localCount == Number(xmlData.lines.line[l-1].@value)){
						//trace("ENTER Anim",localCount,Number(xmlData.lines.line[l-1].@value))
						//var dragBead:MovieClip = targetClip.getChildByName("dragBead") as MovieClip;
						//dragBead.removeEventListener(MouseEvent.MOUSE_DOWN,makeDuplicate);
						trace("animationStart")
						targetClip.preventAnimation.visible =true
						startAnimation(barId, l, l - 1);
						
						
					}
				}
				this["ownNum"+barId] += localCount;
			}
			
			this["countNumber" + barId] = this["ownNum"+barId]
			
			if(this["displayTotal"+barId] == true){
				showResult(barId);
			}
			
		}
		
		private function clearBeads(barId:Number, spikeId:Number):void{
			var arr:Array = this["beads"+barId+"Arr"][spikeId];
			this["beads"+barId+"Arr"][spikeId] = [];
			this["beads"+barId+"RemovedArr"][spikeId] = [];
			var spike:MovieClip = targetClip.getChildByName("spike_"+barId+"_"+spikeId) as MovieClip;	
			for(var i=0;i<arr.length;i++){
				var bead:MovieClip = targetClip.getChildByName(arr[i]) as MovieClip;
				targetClip.removeChild(bead);
			}
			countBeads(barId);
		}		
		
		private function startAnimation(barId:Number, fromSpike:Number, toSpike:Number):void {
			
			/*for (var i = 1; i < 2; i++)
			{
				var targetMc1 = targetClip.getChildByName("showThousandBtn" + i) as MovieClip	
				var targetMc2 = targetClip.getChildByName("hideThousandBtn"+i) as MovieClip
				targetMc1.mouseEnabled = false
				targetMc2.mouseEnabled = false
			}*/
			var tweenCount:Number = 0;
			var timerCount:Number = 0;
			var beadArr:Array = this["beads" + barId + "Arr"][fromSpike];
			var arr:Array = this["beads"+barId+"Arr"][toSpike];
									
			var i:Number = arr.length;
			if(arr[i-1] != undefined)
			var prevBead:MovieClip = targetClip.getChildByName(arr[i-1]) as MovieClip;
			for(var i=0; i<beadArr.length;i++){
				var bead:MovieClip = targetClip.getChildByName(beadArr[i]) as MovieClip;
				var startY:Number = bead.y;
				var myTween:Tween = new Tween(bead, "y", Regular.easeOut, startY, startY - 80, 0.5, true);
				myTween.addEventListener(TweenEvent.MOTION_FINISH, onFinish);
				this["beads" + barId + "Arr"][fromSpike] = [];
				this["beads"+barId+"RemovedArr"][fromSpike] = [];
				function onFinish(e:TweenEvent):void {
					targetClip.preventAnimation.visible =true
					tweenCount++;
					if (tweenCount == beadArr.length) {
						
						var myTimer:Timer = new Timer(100);
						myTimer.addEventListener(TimerEvent.TIMER, timerListener);
						function timerListener (e:TimerEvent):void{
							if(timerCount<tweenCount-1){
								var bead:MovieClip = targetClip.getChildByName(beadArr[timerCount]) as MovieClip;								
								targetClip.removeChild(bead);
								timerCount++;
								//this["beads"+barId+"Arr"][fromSpike] = [];
								//this["beads"+barId+"RemovedArr"][fromSpike] = [];
							}else{
								
								myTimer.stop();
								//trace(fromSpike,toSpike,"toSpike")
								
								//this["beads"+barId+"Arr"][fromSpike] = [];
								//this["beads"+barId+"RemovedArr"][fromSpike] = [];
								var lastBead:MovieClip = targetClip.getChildByName(beadArr[timerCount]) as MovieClip;
								var spike:MovieClip = targetClip.getChildByName("spike_"+barId+"_"+toSpike) as MovieClip;								
								var xTween:Tween = new Tween(lastBead,"x",Regular.easeOut,lastBead.x, spike.x+(spike.width-lastBead.width)/2, 0.5, true);
								xTween.addEventListener(TweenEvent.MOTION_FINISH, onXFinish);
								function onXFinish(e:TweenEvent):void {
									var endY = spike.y + spike.height - lastBead.height
									
									/*var arr:Array = this["beads"+barId+"Arr"][toSpike];
									trace(arr)
									var i:Number = arr.length;
									if(arr[i-1] != undefined)
									var prevBead:MovieClip = targetClip.getChildByName(arr[i-1]) as MovieClip;*/
									var endY:Number = (prevBead!=null) ? prevBead.y - prevBead.height : spike.y + spike.height - lastBead.height;
									var yTween:Tween = new Tween(lastBead, "y", Regular.easeOut, lastBead.y, endY, 1, true);
									yTween.addEventListener(TweenEvent.MOTION_FINISH, onYFinish);
									function onYFinish(e:TweenEvent):void {
										trace("animatinComplete")
										/*for (var i = 1; i < 2; i++)
										{
											targetClip.getChildByName("showThousandBtn"+i).mouseEnabled = true
										}*/
										targetClip.removeChild(lastBead);
										addBead(barId, toSpike);
										
										/*for (var i = 1; i < 2; i++)
										{
											var targetMc1 = targetClip.getChildByName("showThousandBtn" + i) as MovieClip	
											var targetMc2 = targetClip.getChildByName("hideThousandBtn"+i) as MovieClip
											targetMc1.mouseEnabled = true
											targetMc2.mouseEnabled = true
										}*/
										//var dragBead:MovieClip = targetClip.getChildByName("dragBead1") as MovieClip;
										//dragBead.addEventListener(MouseEvent.MOUSE_DOWN,makeDuplicate);
									}
								}
							}
						}
						myTimer.start();
					}
				}
			}			
		}
		
		private function showResult(barId:Number):void{
			/*var answer:MovieClip = targetClip.getChildByName("answer") as MovieClip;
			var txt:TextField = answer.getChildByName("txt") as TextField;
			txt.text = ownNum.toString();
			changeFormat(txt,xmlData.answer.@font,Number(xmlData.answer.@fontSize),uint(xmlData.answer.@fontColor));
			txt.x = (answer.bg.width - txt.width)/2;
			txt.y = (answer.bg.height - txt.height)/2;
			answer.visible = targetClip.hideNumBtn.visible;*/
			
			var myAnswerBox = targetClip.getChildByName("answerBox" + barId);
			
			var myTextBox = myAnswerBox.getChildByName("inputTxt");
			myTextBox.text = this["ownNum" + barId];
			
		}		
	}
}